SystemOrganization addCategory: #'Sphero-Etoys'!
SystemOrganization addCategory: #'Sphero-Core'!

Player subclass: #SpheroPlayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sphero-Etoys'!

!SpheroPlayer class methodsFor: 'as yet unclassified' stamp: 'Richo 7/31/2012 18:03'!
isUniClass
	^ self ~~ self officialClass! !

!SpheroPlayer class methodsFor: 'as yet unclassified' stamp: 'Richo 7/31/2012 18:03'!
officialClass
	^ SpheroPlayer! !

!SpheroPlayer class methodsFor: 'as yet unclassified' stamp: 'Richo 7/31/2012 18:03'!
wantsChangeSetLogging
	"Log changes for Player itself, but not for automatically-created subclasses like Player1, Player2, but *do* log it for uniclasses that have been manually renamed."

	^ (self == self officialClass or:
		[(self name beginsWith: self officialClass asString) not]) or:
			[Preferences universalTiles]! !

!SpheroPlayer methodsFor: 'sphero-connection' stamp: 'Richo 7/31/2012 17:37'!
connect
	^ self sendMessageToCostume: #connect! !

!SpheroPlayer methodsFor: 'sphero-connection' stamp: 'Richo 7/31/2012 17:37'!
disconnect
	^ self sendMessageToCostume: #disconnect! !

!SpheroPlayer methodsFor: 'sphero-connection' stamp: 'Richo 7/31/2012 17:36'!
getIsConnected
	^ self sendMessageToCostume: #isConnected! !

!SpheroPlayer methodsFor: 'sphero-connection' stamp: 'Richo 7/31/2012 17:36'!
getPortName
	^ self sendMessageToCostume: #portName! !

!SpheroPlayer methodsFor: 'sphero-sensors' stamp: 'Richo 8/1/2012 14:56'!
getSpheroAccelX
	^ self sendMessageToCostume: #spheroAccelX! !

!SpheroPlayer methodsFor: 'sphero-sensors' stamp: 'Richo 8/1/2012 14:56'!
getSpheroAccelY
	^ self sendMessageToCostume: #spheroAccelY! !

!SpheroPlayer methodsFor: 'sphero-sensors' stamp: 'Richo 8/1/2012 14:56'!
getSpheroAccelZ
	^ self sendMessageToCostume: #spheroAccelZ! !

!SpheroPlayer methodsFor: 'sphero-misc' stamp: 'Richo 8/1/2012 15:43'!
getSpheroBackLedBrightness
	^ self sendMessageToCostume: #spheroBackLedBrightness! !

!SpheroPlayer methodsFor: 'sphero-misc' stamp: 'Richo 8/1/2012 14:58'!
getSpheroBattery
	^ self sendMessageToCostume: #spheroBattery! !

!SpheroPlayer methodsFor: 'sphero-misc' stamp: 'Richo 7/31/2012 17:33'!
getSpheroColor
	^ self sendMessageToCostume: #spheroColor! !

!SpheroPlayer methodsFor: 'sphero-sensors' stamp: 'Richo 8/1/2012 14:56'!
getSpheroGyroX
	^ self sendMessageToCostume: #spheroGyroX! !

!SpheroPlayer methodsFor: 'sphero-sensors' stamp: 'Richo 8/1/2012 14:56'!
getSpheroGyroY
	^ self sendMessageToCostume: #spheroGyroY! !

!SpheroPlayer methodsFor: 'sphero-sensors' stamp: 'Richo 8/1/2012 14:56'!
getSpheroGyroZ
	^ self sendMessageToCostume: #spheroGyroZ! !

!SpheroPlayer methodsFor: 'sphero-misc' stamp: 'Richo 7/31/2012 17:34'!
getSpheroHeading
	^ self sendMessageToCostume: #spheroHeading! !

!SpheroPlayer methodsFor: 'sphero-misc' stamp: 'Richo 8/1/2012 14:58'!
getSpheroNumOfCharges
	^ self sendMessageToCostume: #spheroNumOfCharges! !

!SpheroPlayer methodsFor: 'sphero-misc' stamp: 'Richo 7/31/2012 17:34'!
getSpheroPitch
	^ self sendMessageToCostume: #spheroPitch! !

!SpheroPlayer methodsFor: 'sphero-misc' stamp: 'Richo 8/1/2012 14:58'!
getSpheroPowerState
	^ self sendMessageToCostume: #spheroPowerState! !

!SpheroPlayer methodsFor: 'sphero-misc' stamp: 'Richo 7/31/2012 17:34'!
getSpheroRoll
	^ self sendMessageToCostume: #spheroRoll! !

!SpheroPlayer methodsFor: 'sphero-misc' stamp: 'Richo 7/31/2012 17:34'!
getSpheroSpeed
	^ self sendMessageToCostume: #spheroSpeed! !

!SpheroPlayer methodsFor: 'sphero-misc' stamp: 'Richo 8/1/2012 14:58'!
getSpheroTimeSinceCharge
	^ self sendMessageToCostume: #spheroTimeSinceCharge! !

!SpheroPlayer methodsFor: 'sphero-misc' stamp: 'Richo 7/31/2012 17:34'!
getSpheroYaw
	^ self sendMessageToCostume: #spheroYaw! !

!SpheroPlayer methodsFor: 'sphero-misc' stamp: 'Richo 7/31/2012 17:34'!
getStabilization
	^ self sendMessageToCostume: #spheroStabilization! !

!SpheroPlayer methodsFor: 'sphero-connection' stamp: 'Richo 7/31/2012 17:37'!
setPortName: aSymbol 
	^ self sendMessageToCostume: #portName: with: aSymbol! !

!SpheroPlayer methodsFor: 'sphero-misc' stamp: 'Richo 8/1/2012 15:44'!
setSpheroBackLedBrightness: aNumber
	^ self sendMessageToCostume: #spheroBackLedBrightness: with: aNumber! !

!SpheroPlayer methodsFor: 'sphero-misc' stamp: 'Richo 7/31/2012 17:33'!
setSpheroColor: aColor
	^ self sendMessageToCostume: #spheroColor: with: aColor! !

!SpheroPlayer methodsFor: 'sphero-misc' stamp: 'Richo 7/31/2012 17:35'!
setSpheroHeading: aNumber
	^ self sendMessageToCostume: #spheroHeading: with: aNumber! !

!SpheroPlayer methodsFor: 'sphero-misc' stamp: 'Richo 7/31/2012 17:35'!
setSpheroSpeed: aNumber
	^ self sendMessageToCostume: #spheroSpeed: with: aNumber! !

!SpheroPlayer methodsFor: 'sphero-misc' stamp: 'Richo 7/31/2012 17:35'!
setStabilization: aBoolean
	^ self sendMessageToCostume: #spheroStabilization: with: aBoolean ! !

Object subclass: #Sphero
	instanceVariableNames: 'protocol speed heading pitch roll yaw color stabilization powerState battVoltage numCharges timeSinceCharge lastUpdateMs accelX accelY accelZ gyroX gyroY gyroZ backLedOutput'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sphero-Core'!

!Sphero methodsFor: 'accessing' stamp: 'Richo 8/1/2012 15:02'!
accelX
	^ accelX! !

!Sphero methodsFor: 'accessing' stamp: 'Richo 8/1/2012 15:02'!
accelY
	^ accelY! !

!Sphero methodsFor: 'accessing' stamp: 'Richo 8/1/2012 15:02'!
accelZ
	^ accelZ! !

!Sphero methodsFor: 'accessing' stamp: 'Richo 8/1/2012 15:38'!
backLedOutput
	^ backLedOutput! !

!Sphero methodsFor: 'accessing' stamp: 'Richo 8/9/2012 15:30'!
backLedOutput: aNumber
	backLedOutput := aNumber.
	self sendBackLedOutputCommand! !

!Sphero methodsFor: 'accessing' stamp: 'Richo 11/5/2012 17:22'!
battVoltage
	"Volt * 100"
	^ battVoltage! !

!Sphero methodsFor: 'sending-receiving' stamp: 'Richo 8/1/2012 16:37'!
bitSigned16: a
	^ a > 32768
		ifTrue: [-1 * (65536 - a)]
		ifFalse: a! !

!Sphero methodsFor: 'accessing' stamp: 'Richo 7/31/2012 16:08'!
color
	^ color! !

!Sphero methodsFor: 'accessing' stamp: 'Richo 8/9/2012 15:29'!
color: aColor
	aColor = color ifTrue: [^ self].
	color := aColor.
	self sendColorCommand! !

!Sphero methodsFor: 'connection' stamp: 'Richo 8/9/2012 15:34'!
connectOnPort: portName
	protocol
		connectOnPort: portName;
		when: #newData send: #updateData: to: self.
	self isConnected 
		ifTrue: [self initializeData; 
					initializeSampling]! !

!Sphero methodsFor: 'connection' stamp: 'Richo 8/1/2012 16:42'!
disconnect
	protocol disconnect! !

!Sphero methodsFor: 'sending-receiving' stamp: 'Richo 8/1/2012 16:37'!
get16BitData: index from: packet
	^ ((packet at: index) bitShift: 8) bitOr: (packet at: index + 1)! !

!Sphero methodsFor: 'sending-receiving' stamp: 'Richo 8/1/2012 16:37'!
get16BitSignedData: index from: packet
	^ self bitSigned16: (self get16BitData: index from: packet)! !

!Sphero methodsFor: 'accessing' stamp: 'Richo 8/1/2012 15:02'!
gyroX
	^ gyroX! !

!Sphero methodsFor: 'accessing' stamp: 'Richo 8/1/2012 15:02'!
gyroY
	^ gyroY! !

!Sphero methodsFor: 'accessing' stamp: 'Richo 8/1/2012 15:02'!
gyroZ
	^ gyroZ! !

!Sphero methodsFor: 'accessing' stamp: 'Richo 7/31/2012 16:10'!
heading
	^ heading! !

!Sphero methodsFor: 'accessing' stamp: 'Richo 8/1/2012 15:50'!
heading: value
	heading := (value \\ 360) asInteger.
	self sendRollCommand! !

!Sphero methodsFor: 'initialize-release' stamp: 'Richo 8/9/2012 15:33'!
initialize
	super initialize.
	speed := heading := pitch := roll := yaw := lastUpdateMs := powerState := battVoltage := numCharges := timeSinceCharge := lastUpdateMs := accelX := accelY := accelZ := gyroX := gyroY := gyroZ := backLedOutput := 0.
	color := Color white.
	stabilization := true.
	protocol := SpheroProtocol new! !

!Sphero methodsFor: 'initialize-release' stamp: 'Richo 8/9/2012 15:33'!
initializeData
	"It initializes the Sphero variables (such as the color, speed, 
	heading, stabilization, and such) using the value of the inst
	vars."
	self sendColorCommand;
		sendRollCommand;
		sendStabilizationCommand;
		sendBackLedOutputCommand;
		sendGetPowerStateCommand! !

!Sphero methodsFor: 'initialize-release' stamp: 'Richo 8/1/2012 16:42'!
initializeSampling
	protocol
		sendTo: 2
		command: 16r11
		data: {0. "n1"
				16r0A. "n2"
				0. "m1"
				1. "m2"
				0. "mask1"
				16r07. "mask1 2"
				16rFC. "mask1 3"
				0. "mask1 4"
				0. "packet limit"
				"0." "mask2"
				"0." "mask2 2"
				"1." "mask2 3"
				"16r80" "mask2 4"}! !

!Sphero methodsFor: 'connection' stamp: 'Richo 8/1/2012 16:42'!
isConnected
	^ protocol isConnected ! !

!Sphero methodsFor: 'accessing' stamp: 'Richo 8/1/2012 15:01'!
numCharges
	^ numCharges! !

!Sphero methodsFor: 'accessing' stamp: 'Richo 7/31/2012 16:08'!
pitch
	^ pitch! !

!Sphero methodsFor: 'accessing' stamp: 'Richo 8/1/2012 15:01'!
powerState
	^ powerState! !

!Sphero methodsFor: 'accessing' stamp: 'Richo 7/31/2012 16:08'!
roll
	^ roll! !

!Sphero methodsFor: 'sending-receiving' stamp: 'Richo 8/9/2012 15:30'!
sendBackLedOutputCommand
	protocol 
		sendTo: 2
		command: 16r21
		data: {backLedOutput \\ 256}! !

!Sphero methodsFor: 'sending-receiving' stamp: 'Richo 8/9/2012 15:29'!
sendColorCommand
	protocol 
		sendTo: 2
		command: 16r20
		data: {(color red * 255) asInteger.
				(color green * 255) asInteger.
				(color blue * 255) asInteger.
				0}! !

!Sphero methodsFor: 'sending-receiving' stamp: 'Richo 8/1/2012 16:43'!
sendGetPowerStateCommand
	protocol 
		sendTo: 0
		seq: 255
		command: 16r20
		data: #[]! !

!Sphero methodsFor: 'sending-receiving' stamp: 'Richo 8/1/2012 16:42'!
sendRollCommand
	protocol
		sendTo: 2 
		command: 16r30
		data: {speed.
				heading bitShift: -8.
				heading bitAnd: 255.
				1}! !

!Sphero methodsFor: 'sending-receiving' stamp: 'Richo 8/9/2012 15:30'!
sendStabilizationCommand
	protocol 
		sendTo: 2
		command: 16r2
		data: {stabilization asBit}! !

!Sphero methodsFor: 'accessing' stamp: 'Richo 7/31/2012 16:11'!
speed
	^ speed! !

!Sphero methodsFor: 'accessing' stamp: 'Richo 8/1/2012 16:27'!
speed: value
	speed := (value \\ 256) asInteger.
	self sendRollCommand ! !

!Sphero methodsFor: 'accessing' stamp: 'Richo 7/31/2012 16:12'!
stabilization
	^ stabilization! !

!Sphero methodsFor: 'accessing' stamp: 'Richo 8/9/2012 15:30'!
stabilization: aBoolean
	stabilization := aBoolean.
	self sendStabilizationCommand! !

!Sphero methodsFor: 'accessing' stamp: 'Richo 8/1/2012 15:02'!
timeSinceCharge
	^ timeSinceCharge! !

!Sphero methodsFor: 'sending-receiving' stamp: 'Richo 8/1/2012 16:42'!
updateData: data
	| now |
	"Ask for power info every second"
	now := Time millisecondClockValue.
	now - lastUpdateMs > 1000
		ifTrue: [self sendGetPowerStateCommand.
			lastUpdateMs := now].

	"The third element is message response"
	(data at: 3) = 3
		ifTrue: ["Sensor data"
			pitch := self get16BitSignedData: 6 from: data.
			roll := self get16BitSignedData: 8 from: data.
			yaw := self get16BitSignedData: 10 from: data.
			accelX := self get16BitSignedData: 12 from: data.
			accelY := self get16BitSignedData: 14 from: data.
			accelZ := self get16BitSignedData: 16 from: data.
			gyroX := self get16BitSignedData: 18 from: data.
			gyroY := self get16BitSignedData: 20 from: data.
			gyroZ := self get16BitSignedData: 22 from: data.
			^ self].

	"The fourth element is the seq (we always send 1 except for the power data)"
	(data at: 4) = 255
		ifTrue: [
			(data at: 6) ~= 1 ifTrue: [^ self].
			powerState := (data at: 7).
			battVoltage := self get16BitData: 8 from: data.
			numCharges := self get16BitData: 10 from: data.
			timeSinceCharge := self get16BitData: 12 from: data.
			^ self].! !

!Sphero methodsFor: 'accessing' stamp: 'Richo 7/31/2012 16:07'!
yaw
	^ yaw! !

Object subclass: #SpheroProtocol
	instanceVariableNames: 'port state currentPacket steppingProcess'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sphero-Core'!

!SpheroProtocol methodsFor: 'connection' stamp: 'Richo 8/1/2012 16:23'!
connectOnPort: aString
	self isConnected ifTrue: [^ self].
	port := SerialPort new baudRate: 57600.
	port := port
				openPort: (('COM*' match: aString)
						ifTrue: [aString asInteger]
						ifFalse: [aString]).
	self isConnected ifTrue: [self startProcess]! !

!SpheroProtocol methodsFor: 'connection' stamp: 'Richo 8/1/2012 16:23'!
disconnect
	self isConnected ifFalse: [^ self].
	self stopProcess.
	port close.
	port := nil.
	self initialize! !

!SpheroProtocol methodsFor: 'sending-receiving' stamp: 'Richo 7/31/2012 16:46'!
getCRC: packet
	"Assumes the argument is the whole packet with the space for the CRC,
	regardless of its value"
	| sum |
	sum := 0.
	3 to: packet size - 1 do: [:i | sum := sum + (packet at: i)].
	^ (sum \\ 256) bitXor: 2r11111111! !

!SpheroProtocol methodsFor: 'initialize-release' stamp: 'Richo 8/1/2012 16:25'!
initialize
	super initialize.
	state := #h1! !

!SpheroProtocol methodsFor: 'connection' stamp: 'Richo 7/31/2012 15:13'!
isConnected
	^ port notNil! !

!SpheroProtocol methodsFor: 'sending-receiving' stamp: 'Richo 8/1/2012 16:20'!
parse: data
	data do: [:b |
		state caseOf: {
			[#h1] -> [b = 255
				ifTrue: [currentPacket := OrderedCollection with: b.
					state := #h2]].
			[#h2] -> [(b = 255 or: [b = 254])
				ifTrue: [currentPacket add: b.
					state := #MRSP]].
			[#MRSP] -> [currentPacket add: b.
					state := #SEQ].
			[#SEQ] -> [currentPacket add: b.
					state := #DLEN].
			[#DLEN] -> [currentPacket add: b.
					state := b = 1 ifTrue: [#CRC] ifFalse: [#DATA]].
			[#DATA] -> [currentPacket add: b.
					(currentPacket size - 5) = ((currentPacket at: 5) - 1)
						ifTrue: [state := #CRC]].
			[#CRC] -> [currentPacket add: b.
					(currentPacket last = (self getCRC: currentPacket))
						ifTrue: [self triggerEvent: #newData with: currentPacket asByteArray].
					state := #h1]
		}]! !

!SpheroProtocol methodsFor: 'sending-receiving' stamp: 'Richo 8/1/2012 16:21'!
readInput
	self isConnected ifFalse: [^ self].
	self parse: port readByteArray.
! !

!SpheroProtocol methodsFor: 'sending-receiving' stamp: 'Richo 8/1/2012 13:33'!
sendTo: addr command: command data: data
	self sendTo: addr seq: 1 command: command data: data! !

!SpheroProtocol methodsFor: 'sending-receiving' stamp: 'Richo 8/1/2012 16:22'!
sendTo: addr seq: seq command: command data: data
	| buff |
	self isConnected ifFalse: [^ self].
	buff := {255.
			255.
			addr.
			command.
			seq.
			data size + 1},
			data,
			{0}.
	buff atLast: 1 put: (self getCRC: buff).
	port nextPutAll: buff asByteArray

	! !

!SpheroProtocol methodsFor: 'connection' stamp: 'Richo 8/1/2012 16:28'!
startProcess
	steppingProcess := [[self readInput.
			10 milliSeconds asDelay wait] repeat] forkNamed: self asString , ' - In'! !

!SpheroProtocol methodsFor: 'connection' stamp: 'Richo 8/1/2012 16:28'!
stopProcess
	steppingProcess ifNotNil: [:p | p terminate].
	steppingProcess := nil! !

CircleMorph subclass: #SpheroMorph
	instanceVariableNames: 'sphero portName logo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sphero-Etoys'!

SpheroMorph class
	instanceVariableNames: 'lastPortName form'!

SpheroMorph class
	instanceVariableNames: 'lastPortName form'!

!SpheroMorph class methodsFor: 'viewer categories' stamp: 'Richo 11/5/2012 17:28'!
additionsToViewerCategories
^ #(

(#'sphero - connection' (
#(command connect 'Connects this device' )
#(command disconnect 'Disconnects this device' )
#(slot isConnected 'Shows if the device is connected' Boolean readOnly Player getIsConnected Player unused )
#(slot portName 'Name of the OS port in which the device is connected' PEPort readWrite Player getPortName Player setPortName: )
))

(#'sphero - sensors' (
#(slot #spheroPitch 'Shows the pitch value of the Sphero' Number readOnly Player getSpheroPitch Player unused )
#(slot #spheroRoll 'Shows the roll value of the Sphero' Number readOnly Player getSpheroRoll Player unused )
#(slot #spheroYaw 'Shows the yaw value of the Sphero' Number readOnly Player getSpheroYaw Player unused )
#(slot #spheroAccelX 'Shows the acceleration of the Sphero along the x axis' Number readOnly Player getSpheroAccelX Player unused )
#(slot #spheroAccelY 'Shows the acceleration of the Sphero along the y axis' Number readOnly Player getSpheroAccelY Player unused )
#(slot #spheroAccelZ 'Shows the acceleration of the Sphero along the z axis' Number readOnly Player getSpheroAccelZ Player unused )
#(slot #spheroGyroX 'Shows the gyroscope value of the Sphero along the x axis' Number readOnly Player getSpheroGyroX Player unused )
#(slot #spheroGyroY 'Shows the gyroscope value of the Sphero along the y axis' Number readOnly Player getSpheroGyroY Player unused )
#(slot #spheroGyroZ 'Shows the gyroscope value of the Sphero along the z axis' Number readOnly Player getSpheroGyroZ Player unused )
#(slot #stabilization 'Enables or disables the Sphero stabilization' Boolean readWrite Player getStabilization Player setStabilization:  )
))

(#'sphero - movement' (
#(slot #spheroHeading 'Lets you change the direction in which the Sphero is facing' Number readWrite Player getSpheroHeading Player setSpheroHeading:  )
#(slot #spheroSpeed 'Lets you change the speed at which the Sphero is moving forward (0 means the Sphero is still)' Number readWrite Player getSpheroSpeed Player setSpheroSpeed:  )
#(slot #stabilization 'Enables or disables the Sphero stabilization' Boolean readWrite Player getStabilization Player setStabilization:  )
))

(#'sphero - misc' (
#(slot #spheroColor 'Let''s you change Sphero''s color' Color readWrite Player getSpheroColor Player setSpheroColor:  )
#(slot #spheroPowerState 'Shows the state of the Sphero battery (charging/ok/low/critical)' SpheroPowerState readOnly Player getSpheroPowerState Player unused)
#(slot #spheroBattery 'Shows the voltage of the Sphero battery (in 100ths of a volt)' Number readOnly Player getSpheroBattery Player unused )
#(slot #spheroNumOfCharges 'Shows how many times the Sphero has been charged' Number readOnly Player getSpheroNumOfCharges Player unused )
#(slot #spheroTimeSinceCharge 'Shows how much time has passed since the Sphero was charged' Number readOnly Player getSpheroTimeSinceCharge Player unused )
#(slot #spheroBackLedBrightness 'Lets you change the brightness of the Sphero back led' Number readWrite Player getSpheroBackLedBrightness Player setSpheroBackLedBrightness:  )
))


)! !

!SpheroMorph class methodsFor: 'parts bin' stamp: 'Richo 7/31/2012 17:55'!
descriptionForPartsBin
	"Answer a description for use in parts bins"
	^ self
		partName: 'Sphero' translatedNoop
		categories: ((PEUtilities isPEProject: Project current)
								ifTrue: [{'Physical Etoys' translatedNoop}]
								ifFalse: [#()])
		documentation: 'An object that lets you communicate with a Sphero ball' translatedNoop! !

!SpheroMorph class methodsFor: 'form' stamp: 'Richo 7/31/2012 17:59'!
form
	^ form ifNil: [self initializeForm]! !

!SpheroMorph class methodsFor: 'class initialization' stamp: 'Richo 11/6/2012 15:19'!
initialize
	"
	self initialize
	"
	'charging' translatedNoop.
	'good' translatedNoop.
	'low' translatedNoop.
	'critical' translatedNoop.
	Vocabulary addStandardVocabulary: (SymbolListType new vocabularyName: #SpheroPowerState;
			 symbols: #(#charging #good #low #critical ))! !

!SpheroMorph class methodsFor: 'form' stamp: 'Richo 7/31/2012 18:00'!
initializeForm
	^ form := PEUtilities formFromEncodedPNG: 'iVBORw0KGgoAAAANSUhEUgAAADMAAAAxCAYAAAB3aZEhAAAABHNCSVQFBQUBSsjp7wAAAV5J
REFUeF7lmksOwjAMRHP8LHssjpQdsGEBiHimGX9CI1VVJURkvzoe223tuN1bf14Zd5f12qB/
bBj9LF1ZhFyJZRPqalIVCElJVSEkM+iEJ8cY8BVLCPQgY4BpmAshwGMKI76MciFkEPEw5M0g
GSFRTOQTmngkyhCIEJSLkolQhGBDAmNkiRB7emUaYhJi1HMFQ8w8VD1WKMWAZHrJey50CJZ3
xLHiGXt27AjzirdysE81UaysqmqE5JyM0INofcJ4HM476lMMrU8Yj8P7zLSYSz3y478lv1eS
YSpSlihORhQzTE3P1i/hMVODzPVjpuppFpxn2Jjj8oxQASCx46sAArWZtOpktJlaNcdVnCfe
8fTSedpH+5tK05igle4BsJ3MskSmnc3d+mYr3f+9OprFCGlmnglzGT2RAvMZvwmaeIYpUd0R
U2e51tpl6nzdLzdcV+QXGiHLm0jaKkLiAefrxnQjv0MqAAAAAElFTkSuQmCC'! !

!SpheroMorph class methodsFor: 'accessing' stamp: 'Richo 7/31/2012 17:47'!
lastPortName
	"
	lastPortName := nil.
	"
	^ lastPortName! !

!SpheroMorph class methodsFor: 'accessing' stamp: 'Richo 7/31/2012 17:47'!
lastPortName: aSymbol
	lastPortName := aSymbol! !

!SpheroMorph methodsFor: 'viewer category filter' stamp: 'Richo 7/31/2012 17:50'!
categoriesForViewer
	^self validCategories , #(scripting)! !

!SpheroMorph methodsFor: 'accessing' stamp: 'Richo 8/1/2012 15:55'!
color: aColor
	sphero color: aColor.
	super fillStyle: ((GradientFillStyle  ramp: { 0.0 -> Color white. 1.0 -> aColor})
			origin: self topLeft + (50 @ 50);
			direction: 163@60;
			normal: -60@163;
			radial: true;
			yourself)
! !

!SpheroMorph methodsFor: 'connection' stamp: 'Richo 7/31/2012 17:45'!
connect
	[sphero connectOnPort: portName]
			on: Error
			do: [:err | self inform: err description]! !

!SpheroMorph methodsFor: 'initialize-release' stamp: 'Richo 7/31/2012 17:50'!
delete
	self isConnected ifTrue: [self disconnect].
	super delete.! !

!SpheroMorph methodsFor: 'connection' stamp: 'Richo 7/31/2012 17:46'!
disconnect
	sphero disconnect! !

!SpheroMorph methodsFor: 'accessing' stamp: 'Richo 8/7/2012 18:09'!
extent: newExtent
	super extent: 150@150! !

!SpheroMorph methodsFor: 'accessing' stamp: 'Richo 7/31/2012 18:12'!
fillStyle: aFillStyle
	self color: aFillStyle asColor! !

!SpheroMorph methodsFor: 'initialize-release' stamp: 'Richo 7/31/2012 18:14'!
initialize
	super initialize.
	sphero := Sphero new.
	self extent: 150@150;
		color: Color white;
		borderColor: (Color r: 0.0 g: 0.548 b: 0.806);
		borderWidth: 3;
		clipSubmorphs: true;
		yourself.
	self initializePortName;
		initializeSpheroLogo! !

!SpheroMorph methodsFor: 'initialize-release' stamp: 'Richo 7/31/2012 17:47'!
initializePortName
	| availablePorts |
	availablePorts := PESerialPort availablePorts.
	(availablePorts includes: self class lastPortName)
		ifFalse: [self class lastPortName: availablePorts first].
	portName := self class lastPortName! !

!SpheroMorph methodsFor: 'initialize-release' stamp: 'Richo 7/31/2012 18:01'!
initializeSpheroLogo
	logo := (SketchMorph withForm: self class form)
		center: self center.
	self addMorphBack: logo! !

!SpheroMorph methodsFor: 'initialize-release' stamp: 'Richo 7/31/2012 17:56'!
initializeToStandAlone
	self initialize! !

!SpheroMorph methodsFor: 'connection' stamp: 'Richo 7/31/2012 17:46'!
isConnected
	^ sphero isConnected! !

!SpheroMorph methodsFor: 'initialize-release' stamp: 'Richo 7/31/2012 17:36'!
newPlayerInstance
	^ SpheroPlayer newUserInstance! !

!SpheroMorph methodsFor: 'accessing' stamp: 'Richo 7/31/2012 17:46'!
portName
	^ portName! !

!SpheroMorph methodsFor: 'accessing' stamp: 'Richo 7/31/2012 17:46'!
portName: aSymbol 
	self isConnected
		ifTrue: [self disconnect].
	portName := aSymbol = #'other...'
				ifTrue: [(FillInTheBlank request: 'Port name:' translated) asSymbol]
				ifFalse: [aSymbol].
	self class lastPortName: portName! !

!SpheroMorph methodsFor: 'fileOut' stamp: 'Richo 7/31/2012 17:50'!
prepareToBeSaved
"When saving a project be sure to disconnect the board, otherwise we will have a lot of problems"
	super prepareToBeSaved.
	self isConnected ifTrue: [self disconnect]! !

!SpheroMorph methodsFor: 'accessing' stamp: 'Richo 8/1/2012 15:09'!
spheroAccelX
	^ sphero accelX ! !

!SpheroMorph methodsFor: 'accessing' stamp: 'Richo 8/1/2012 15:10'!
spheroAccelY
	^ sphero accelY! !

!SpheroMorph methodsFor: 'accessing' stamp: 'Richo 8/1/2012 15:10'!
spheroAccelZ
	^ sphero accelZ! !

!SpheroMorph methodsFor: 'accessing' stamp: 'Richo 8/1/2012 15:42'!
spheroBackLedBrightness
	^ sphero backLedOutput! !

!SpheroMorph methodsFor: 'accessing' stamp: 'Richo 8/1/2012 15:42'!
spheroBackLedBrightness: aNumber
	sphero backLedOutput: aNumber! !

!SpheroMorph methodsFor: 'accessing' stamp: 'Richo 8/1/2012 15:07'!
spheroBattery
	^ sphero battVoltage! !

!SpheroMorph methodsFor: 'accessing' stamp: 'Richo 7/31/2012 17:48'!
spheroColor
	^ sphero color! !

!SpheroMorph methodsFor: 'accessing' stamp: 'Richo 7/31/2012 18:13'!
spheroColor: aColor
	self color: aColor! !

!SpheroMorph methodsFor: 'accessing' stamp: 'Richo 8/1/2012 15:10'!
spheroGyroX
	^ sphero gyroX! !

!SpheroMorph methodsFor: 'accessing' stamp: 'Richo 8/1/2012 15:10'!
spheroGyroY
	^ sphero gyroY! !

!SpheroMorph methodsFor: 'accessing' stamp: 'Richo 8/1/2012 15:10'!
spheroGyroZ
	^ sphero gyroZ! !

!SpheroMorph methodsFor: 'accessing' stamp: 'Richo 7/31/2012 17:48'!
spheroHeading
	^ sphero heading! !

!SpheroMorph methodsFor: 'accessing' stamp: 'Richo 7/31/2012 17:49'!
spheroHeading: aNumber
	^ sphero heading: aNumber! !

!SpheroMorph methodsFor: 'accessing' stamp: 'Richo 8/1/2012 15:07'!
spheroNumOfCharges
	^ sphero numCharges! !

!SpheroMorph methodsFor: 'accessing' stamp: 'Richo 7/31/2012 17:49'!
spheroPitch
	^ sphero pitch! !

!SpheroMorph methodsFor: 'accessing' stamp: 'Richo 11/6/2012 15:19'!
spheroPowerState
	^ sphero powerState caseOf: {
			[1] -> [#charging].
			[2] -> [#good].
			[3] -> [#low].
			[3] -> [#critical]
		} otherwise: [#invalid]! !

!SpheroMorph methodsFor: 'accessing' stamp: 'Richo 7/31/2012 17:49'!
spheroRoll
	^ sphero roll! !

!SpheroMorph methodsFor: 'accessing' stamp: 'Richo 7/31/2012 17:48'!
spheroSpeed
	^ sphero speed! !

!SpheroMorph methodsFor: 'accessing' stamp: 'Richo 7/31/2012 17:49'!
spheroSpeed: aNumber
	^ sphero speed: aNumber! !

!SpheroMorph methodsFor: 'accessing' stamp: 'Richo 7/31/2012 17:49'!
spheroStabilization
	^ sphero stabilization! !

!SpheroMorph methodsFor: 'accessing' stamp: 'Richo 7/31/2012 17:49'!
spheroStabilization: aBoolean
	^ sphero stabilization: aBoolean! !

!SpheroMorph methodsFor: 'accessing' stamp: 'Richo 8/1/2012 15:09'!
spheroTimeSinceCharge
	^ sphero timeSinceCharge ! !

!SpheroMorph methodsFor: 'accessing' stamp: 'Richo 7/31/2012 17:49'!
spheroYaw
	^ sphero yaw! !

!SpheroMorph methodsFor: 'viewer category filter' stamp: 'Richo 7/31/2012 17:51'!
validCategories
	"Returns valid categories for the Sphero object"
	^(self class additionsToViewerCategories collect: [:each| each first])! !
SpheroMorph initialize!
